import { Base, INotifyPropertyChanged, PropertyChangedEventArgs, Type } from "igniteui-react-core";
import { PropertyEditorValueType } from "./PropertyEditorValueType";
import { PropertyEditorPropertyDescriptionButtonClickEventArgs } from "./PropertyEditorPropertyDescriptionButtonClickEventArgs";
import { PropertyEditorPropertyDescriptionChangedEventArgs } from "./PropertyEditorPropertyDescriptionChangedEventArgs";
import { PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs } from "./PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs";
import { ObservableCollection$1 } from "igniteui-react-core";
import { TypeDescriptionContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class PropertyEditorPropertyDescription extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private ah;
    get al(): string;
    set al(a: string);
    private af;
    get aj(): string;
    set aj(a: string);
    private m;
    get n(): PropertyEditorValueType;
    set n(a: PropertyEditorValueType);
    private ag;
    get ak(): string;
    set ak(a: string);
    private o;
    get q(): boolean;
    set q(a: boolean);
    private ae;
    get ai(): string;
    set ai(a: string);
    private a;
    get c(): string[];
    set c(a: string[]);
    private b;
    get d(): string[];
    set d(a: string[]);
    private ab;
    get ad(): any;
    set ad(a: any);
    private u;
    get z(): number;
    set z(a: number);
    private r;
    get w(): number;
    set w(a: number);
    private s;
    get x(): number;
    set x(a: number);
    private t;
    get y(): number;
    set y(a: number);
    private v;
    get aa(): number;
    set aa(a: number);
    private f;
    get g(): PropertyEditorDescriptionObject;
    set g(a: PropertyEditorDescriptionObject);
    private h;
    get i(): PropertyEditorDescriptionObjectCollection;
    set i(a: PropertyEditorDescriptionObjectCollection);
    e: PropertyEditorDataSource;
    private ao;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    p(a: PropertyEditorPropertyDescription): boolean;
    ac(a: string, b: boolean): any;
    an(): void;
    am(): void;
    buttonClicked: (sender: any, args: PropertyEditorPropertyDescriptionButtonClickEventArgs) => void;
    changed: (sender: any, args: PropertyEditorPropertyDescriptionChangedEventArgs) => void;
    targetPropertyUpdating: (sender: any, args: PropertyEditorPropertyDescriptionTargetPropertyUpdatingEventArgs) => void;
    ap(a: string, b: any, c: any): void;
}
/**
 * @hidden
 */
export declare class PropertyEditorPropertyDescriptionCollection extends ObservableCollection$1<PropertyEditorPropertyDescription> {
    static $t: Type;
    constructor();
}
/**
 * @hidden
 */
export declare class PropertyEditorDataSource extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private i;
    get l(): string;
    set l(a: string);
    private a;
    get b(): TypeDescriptionContext;
    set b(a: TypeDescriptionContext);
    private f;
    get g(): PropertyEditorPropertyDescriptionCollection;
    set g(a: PropertyEditorPropertyDescriptionCollection);
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected n(a: string, b: any, c: any): void;
    protected o(a: string, b: any, c: any): void;
    private e;
    private h;
    private p;
    d(a: string, b: boolean): PropertyEditorPropertyDescription;
    private c;
}
/**
 * @hidden
 */
export declare class PropertyEditorDescriptionObject extends Base {
    static $t: Type;
    b: string;
    a: PropertyEditorPropertyDescriptionCollection;
}
/**
 * @hidden
 */
export declare class PropertyEditorDescriptionObjectCollection extends ObservableCollection$1<PropertyEditorDescriptionObject> {
    static $t: Type;
    constructor();
}
